/***************************************************************************
                          kslidesaversetup.ui.h  -  
                             -------------------
    begin                : Sun Mar  2 01:25:52 CST 2003
    copyright            : (C) 2003 by Wojciech Jarosz
    email                : wkjarosz@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qcheckbox.h>
#include <kconfig.h>
#include <klocale.h>
#include <unistd.h>

void KSlideSaverSetup::init()
{
	about = new KAboutDialog(KAboutDialog::AbtPlain|KAboutDialog::AbtProduct|KAboutDialog::AbtTitle, "SlideShow (GL)", KDialogBase::Ok, KDialogBase::Ok, this, "", true, true, "Close");

	about->setAuthor("Wojciech Jarosz", "wkjarosz@hotmail.com", "http://renderedRealities.net/", "");
	about->setTitle("SlideShow (GL)");
	about->setVersion("0.7");
	about->setProduct ("SlideShow (GL)", "0.7", "Wojciech Jarosz", "2003");	

	KFile::Mode mode = static_cast<KFile::Mode>( KFile::Directory |
												KFile::ExistingOnly |
												KFile::LocalOnly );
	imageDirectoryRequester->setMode(mode);

	slideSaverWidget = NULL;
	readConfig();
	updatePreview();
}

void KSlideSaverSetup::saveAndUpdatePreview()
{
	writeConfig();
	if ( slideSaverWidget != NULL )
		delete slideSaverWidget;

	usleep(500000);
	slideSaverWidget = new KSlideSaver( previewFrame );
	slideSaverWidget->move(1,1);
	slideSaverWidget->resize(200,150);

	slideSaverWidget->show();
}

void KSlideSaverSetup::updatePreview()
{
	if ( slideSaverWidget != NULL )
		delete slideSaverWidget;

	usleep(500000);
	slideSaverWidget = new KSlideSaver( previewFrame );
	slideSaverWidget->move(1,1);
	slideSaverWidget->resize(200,150);

	slideSaverWidget->show();
}

void KSlideSaverSetup::okButton_clicked()
{
	writeConfig();
	delete slideSaverWidget;
	delete about;

	accept();
}


void KSlideSaverSetup::writeConfig()
{
	KConfig config("kslidesaverglrc",false,false);
	config.writeEntry("imageDirectory", imageDirectoryRequester->url());
	config.writeEntry("reloadDelay", delaySlider->value());
	config.writeEntry("fade",fadeSlider->value());
	config.writeEntry("randomize", randomizeCheckBox->isChecked());
	config.writeEntry("showImageNames", imageNamesCheckBox->isChecked());
}


void KSlideSaverSetup::readConfig()
{
	KConfig config("kslidesaverglrc",true,false);
	imageDirectoryRequester->setURL(config.readPathEntry("imageDirectory", "$HOME"));
	delaySlider->setValue(config.readNumEntry("reloadDelay", 10));
	fadeSlider->setValue(config.readNumEntry("fade",5));
	randomizeCheckBox->setChecked(config.readBoolEntry("randomize",true));
	imageNamesCheckBox->setChecked(config.readBoolEntry("showImageNames",false));
}


void KSlideSaverSetup::setDelay(int i)
{
	if (slideSaverWidget)
		slideSaverWidget->setDelay(i);
}

void KSlideSaverSetup::setDirectory(const QString& str)
{
	if (slideSaverWidget)
		slideSaverWidget->setDirectory(str);
}

void KSlideSaverSetup::showAbout()
{
	about->show();
}



void KSlideSaverSetup::changeLanguage()
{

}

void KSlideSaverSetup::setRandomize(bool b)
{
	if (slideSaverWidget)
		slideSaverWidget->setRandomize(b);
}

void KSlideSaverSetup::setFadeAmount(int i)
{
	if (slideSaverWidget)
		slideSaverWidget->setFadeAmount(i);
}


void KSlideSaverSetup::setShowImageNames(bool b)
{
	if (slideSaverWidget)
		slideSaverWidget->setShowImageNames(b);
}

