#ifndef BYTERASTER
#define BYTERASTER

#include "common.h"
#include "utility.h"
#include "vec3.h"

class ByteRaster
{
private:
	unsigned char* data;
	int W, H, nchan;

public:
	ByteRaster(int w, int h, int c) : W(w), H(h), nchan(c)
	{
		data = new unsigned char[length()];
	}
	
	~ByteRaster()
	{
		delete[] data;
	}

	int width() const { return W; }
	int height() const { return H; }
	int channels() const { return nchan; }
	int length() const { return W*H*nchan; }

	unsigned char& operator[](int i)       { return data[i]; }
	unsigned char  operator[](int i) const { return data[i]; }

	unsigned char		*pixel(int i, int j)		{ return data + (j*W+i)*nchan; }
	const unsigned char	*pixel(int i, int j) const	{ return data + (j*W+i)*nchan; }

	unsigned char		*head()			{ return data; }
	const unsigned char	*head() const	{ return data; }
};

#endif
