/***************************************************************************
                          imageLoader.cpp  -  description
                             -------------------
    begin                : Thu May 1 2003
    copyright            : (C) 2003 by Wojciech Jarosz
    email                : wkjarosz@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "imageloader.h"
#include "byteraster.h"
#include "pngloader.h"
#include "jpegloader.h"

imageLoader::imageLoader() :
		infile(NULL),
		img(NULL),
		reading(false)
{

}

imageLoader::~imageLoader()
{
	delete img;
}

const ByteRaster* imageLoader::raster() const
{
	return img;
}

int imageLoader::width() const
{
	return (img) ? img->width() : 0;
}

int imageLoader::height() const
{
	return (img) ? img->height() : 0;
}

int imageLoader::channels() const
{
	return (img) ? img->channels() : 0;
}

bool imageLoader::isNull() const
{
	return (img == NULL);
}


imageLoader* imageLoader::inferType(const QString& filename)
{
	if (filename.endsWith(".png") || filename.endsWith(".PNG"))
	{
		return (imageLoader*)(new pngLoader());
	}
	else
	{
		return (imageLoader*)(new jpegLoader());
	}
}
