/***************************************************************************
                          imageLoader.h  -  description
                             -------------------
    begin                : Thu May 1 2003
    copyright            : (C) 2003 by Wojciech Jarosz
    email                : wkjarosz@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef IMAGELOADER
#define IMAGELOADER

// this is needed to make libjpeg work with qt for some reason.
// qt defines INT32, and so does libjpeg, these two defines conflict
#define QT_CLEAN_NAMESPACE
#include <stdio.h>
#include <qstring.h>

class ByteRaster;

class imageLoader
{
public:
	imageLoader();
	virtual ~imageLoader();

	virtual bool read_image(const char * filename) = 0;
	virtual bool start_incremental_image_read(const char* filename) = 0;
	virtual int incremental_image_read(const int& numLines) = 0;
	virtual void finish_incremental_image_read(void) = 0;

	static imageLoader* inferType(const QString& filename);

	const ByteRaster* raster() const;
	int width() const;
	int height() const;
	int channels() const;
	bool isNull() const;

public:
	FILE* infile;
	
	ByteRaster *img;
    bool reading;
};

#endif
